=== src/kconf_update/CMakeLists.txt ===
install( FILES amarok.upd DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )
install( PROGRAMS
         amarok-2.4.1-tokens_syntax_update.pl
         DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR}
       )
