=== supplementary_scripts/neon/distros/ubuntu/cdbs/debian/changelog ===
amarok-nightly-cdbs (1.3.4build1) hardy; urgency=low

  * Neon PPA Build

 -- Project Neon <nightly@getamarok.com>  Tue, 17 Jun 2008 11:56:13 +0200

amarok-nightly-cdbs (1.3.4) hardy; urgency=low

  * Make branch kde from amarok, saves me a lot of headache

 -- Harald Sitter <apachelogger@ubuntu.com>  Tue, 03 Jun 2008 09:35:38 +0200

amarok-nightly-cdbs (1.3.3) hardy; urgency=low

  * Fix the .installs, once and for all (or at least until I finished testing)

 -- Harald Sitter <apachelogger@ubuntu.com>  Tue, 03 Jun 2008 07:02:58 +0200

amarok-nightly-cdbs (1.3.2) hardy; urgency=low

  * Fix logical error

 -- Harald Sitter <apachelogger@ubuntu.com>  Mon, 02 Jun 2008 23:59:31 +0200

amarok-nightly-cdbs (1.3.1) intrepid; urgency=low

  * Make kde-nightly-cdbs not depend on amarok-nightly-cdbs

 -- Harald Sitter <apachelogger@ubuntu.com>  Mon, 02 Jun 2008 14:11:16 +0200

amarok-nightly-cdbs (1.3) hardy; urgency=low

  * Add kde-nightly-cdbs

 -- Harald Sitter <apachelogger@ubuntu.com>  Sat, 31 May 2008 15:01:40 +0200

amarok-nightly-cdbs (1.2build2) hardy; urgency=low

  * Rebuild

 -- Project Neon <nightly@getamarok.com>  Wed, 30 Apr 2008 20:10:20 +0200

amarok-nightly-cdbs (1.2build1) hardy; urgency=low

  * Rebuild

 -- Project Neon <nightly@getamarok.com>  Mon, 14 Apr 2008 18:20:24 +0200

amarok-nightly-cdbs (1.2) hardy; urgency=low

  * Hardy upgrade

 -- Amarok Nightly Builds <nightly@getamarok.com>  Fri, 11 Apr 2008 20:26:22 +0200

amarok-nightly-cdbs (1.1-0~amarok1) gutsy; urgency=low

  * Add default CMake file from hardy

 -- Harald Sitter <apachelogger@ubuntu.com>  Sun, 03 Feb 2008 22:08:09 +0100

amarok-nightly-cdbs (0.1-0~amarok3) gutsy; urgency=low

  * Rebuild

 -- Harald Sitter <apachelogger@ubuntu.com>  Sun, 03 Feb 2008 18:41:02 +0100

amarok-nightly-cdbs (0.1-0~amarok2) gutsy; urgency=low

  * Fixed a minor issue with library deps

 -- Amarok Nightly Builds <nightly@getamarok.com>  Wed, 23 Jan 2008 00:56:53 +0100

amarok-nightly-cdbs (0.1-0~amarok1) gutsy; urgency=low

  * Initial release

 -- Amarok Nightly Builds <nightly@getamarok.com>  Tue, 15 Jan 2008 22:17:58 +0100
