=== supplementary_scripts/neon/distros/ubuntu/cdbs/debian/control ===
Source: amarok-nightly-cdbs
Section: devel
Priority: optional
Maintainer: Project Neon <nightly@getamarok.com>
Build-Depends: debhelper (>= 6), cdbs
Standards-Version: 3.7.3
Homepage: http://amarok.kde.org

Package: amarok-nightly-cdbs
Architecture: all
Depends: debhelper (>= 6), cdbs, cmake, quilt
Description: Build scripts for Project Neon (Amarok Nightly)
 Project Neon build scripts

Package: kde-nightly-cdbs
Architecture: all
Depends: debhelper (>= 6), cdbs, cmake, quilt
Description: Build scripts for Project Neon (KDE Nightly)
 This is a fake package for amarok-nighly-cdbs
